/* ########## 4.10 Miscellaneous ########## */

// Responsive visibility utilities
@each $bp in map-keys($grid-breakpoints) {
   .u-hidden-#{$bp}--up {
      @include media-breakpoint-up($bp) {
         display: none !important;
      }
   }

   .u-hidden-#{$bp}--down {
      @include media-breakpoint-down($bp) {
         display: none !important;
      }
   }
}

.u-shadow--base {
   -webkit-box-shadow: 0 2px 0 rgba(0, 0, 0, 0.05);
   box-shadow: 0 2px 0 rgba(0, 0, 0, 0.05);
}

.u-shadow--1 {
   -webkit-box-shadow: 1px 1px 0 rgba(0, 0, 0, 0.07);
   box-shadow: 0 1px 0 rgba(0, 0, 0, 0.07);
}

.u-shadow--none {
   -webkit-box-shadow: none;
   box-shadow: none;
}

.u-transition {
   @include transition($transition-base);
}

.u-object__position--left {
   object-position: left;
}

.u-object__fit--cover {
   object-fit: cover;
}

.u-no-object__fit .u-object__fit--cover {
   visibility: hidden;
}

.u-cursor--pointer {
   cursor: pointer;
}

.u-cursor--crosshair {
   cursor: crosshair;
}

.u-float--left {
   float: left !important;
}

.u-float--right {
   float: right !important;
}

.u-float--none {
   float: none !important;
}

.u-placeholder--light {

   /* WebKit, Blink, Edge */
   &::-webkit-input-placeholder {
      opacity: 0.1;
      color: #fff;
   }

   /* Mozilla Firefox 19+ */
   &::-moz-placeholder {
      opacity: 0.1;
      color: #fff;
   }

   /* Internet Explorer 10-11 */
   &:-ms-input-placeholder {
      opacity: 0.1;
      color: #fff;
   }
}

.u-placeholder--dark {

   /* WebKit, Blink, Edge */
   &::-webkit-input-placeholder {
      opacity: 0.1;
      color: #000 !important;
   }

   /* Mozilla Firefox 19+ */
   &::-moz-placeholder {
      opacity: 0.1;
      color: #000 !important;
   }

   /* Internet Explorer 10-11 */
   &:-ms-input-placeholder {
      opacity: 0.1;
      color: #000 !important;
   }
}

@mixin do-display($viewport) {
   .u-#{$viewport}--block {
      display: block !important;
   }

   .u-#{$viewport}--inline {
      display: inline !important;
   }

   .u-#{$viewport}--inline-block {
      display: inline-block !important;
   }

   .u-#{$viewport}--none {
      display: none !important;
   }

   .u-#{$viewport}--flex {
      display: flex !important;
   }

   .u-#{$viewport}--table {
      display: table !important;
   }
}

@media (min-width: 480px) {
   @include do-display("xs");
}

@include media-breakpoint-up(sm) {
   @include do-display("sm");
}

@include media-breakpoint-up(md) {
   @include do-display("md");
}

@include media-breakpoint-up(lg) {
   @include do-display("lg");
}

@include media-breakpoint-up(xl) {
   @include do-display("xl");
}

@media (max-width: 479px) {
   .u-hidden-xss--down {
      display: none;
   }
}

@media (min-width: 480px) {
   .u-hidden-xss--up {
      display: none;
   }
}
